from tkinter import *
from tkinter import ttk
import globals
from globals import pause
from draw_3D import get_values_and_draw, get_values_cylinder, xoa_hinh3d
WIDTH = globals.WIDTH
HEIGHT = globals.HEIGHT
GRID_SIZE = globals.GRID_SIZE

def create_root():
    root = Tk()
    root.title("Hệ tọa độ 2D")
    root.geometry("1540x700")
    screen_width = root.winfo_screenwidth()
    screen_height = root.winfo_screenheight()
    x_cordinate = int((screen_width/2) - (1540/2))
    y_cordinate = int((screen_height/2) - (700/2))
    root.geometry("{}x{}+{}+{}".format(1540, 700, x_cordinate, y_cordinate))
    return root

def create_canvas(root):
    canvas = Canvas(root, width=WIDTH, height=HEIGHT)
    canvas.grid(row=1, column=0, sticky=(N, W, E, S))
    return canvas

def gd_chuyen_dong(group2):
    button6 = Button(group2, text="Dừng/Tiếp tục", command=pause, bg="green", fg="orange", width=26, height=1,font=("Arial", 12))
    button6.grid(row=3, column=0, padx=30, pady=10, columnspan=4)
    frame_dia_bay = Frame(group2, bd=1, relief="solid")
    frame_dia_bay.grid(row=1+3, column=0, sticky=N+S+E+W)
    frame_nong_sung = Frame(group2, bd=1, relief="solid")
    frame_nong_sung.grid(row=1+3, column=1, sticky=N+S+E+W)
    frame_bom = Frame(group2, bd=1, relief="solid")
    frame_bom.grid(row=1+4, column=0, sticky=N+S+E+W)
    frame_dan = Frame(group2, bd=1, relief="solid")
    frame_dan.grid(row=1+4, column=1, sticky=N+S+E+W)
    Label(frame_dia_bay, text="ĐĨA BAY", font=("Arial",12, "bold")).grid(row=1+0, column=0, padx=5, pady=5, sticky=W+E, columnspan=2)
    lb3 = Label(frame_dia_bay, text="", font=("Arial",10))
    lb3.grid(row=1+1, column=1, sticky=W)
    lb5 = Label(frame_dia_bay, text="", font=("Arial",10))
    lb5.grid(row=1+2, column=1, sticky=W)
    lb7 = Label(frame_dia_bay, text="", font=("Arial",10))
    lb7.grid(row=1+3, column=1, sticky=W)
    lb9 = Label(frame_dia_bay, text="", font=("Arial",10))
    lb9.grid(row=1+4, column=1, sticky=W)
    lb11 = Label(frame_dia_bay, text="", font=("Arial",10))
    lb11.grid(row=1+5, column=1, sticky=W)
    lb13 = Label(frame_dia_bay, text="", font=("Arial",10))
    lb13.grid(row=1+6, column=1, sticky=W)
    Label(frame_dia_bay, text="T_Elip", font=("Arial",10)).grid(row=1+1, column=0, sticky=W)
    Label(frame_dia_bay, text="T_Tròn1", font=("Arial",10)).grid(row=1+2, column=0, sticky=W)
    Label(frame_dia_bay, text="T_Tròn2", font=("Arial",10)).grid(row=1+3, column=0, sticky=W)
    Label(frame_dia_bay, text="T_Tròn3", font=("Arial",10)).grid(row=1+4, column=0, sticky=W)
    Label(frame_dia_bay, text="T_Tròn4", font=("Arial",10)).grid(row=1+5, column=0, sticky=W)
    Label(frame_dia_bay, text="T_Tròn5", font=("Arial",10)).grid(row=1+6, column=0, sticky=W)
    Label(frame_nong_sung, text="NÒNG SÚNG", font=("Arial",12, "bold")).grid(row=1+0, column=0, padx=5, pady=5, sticky=W+E, columnspan=2)
    lb16 = Label(frame_nong_sung, text="", font=("Arial",10))
    lb16.grid(row=1+1, column=1, sticky=W)
    lb18 = Label(frame_nong_sung, text="", font=("Arial",10))
    lb18.grid(row=1+2, column=1, sticky=W)
    lb20 = Label(frame_nong_sung, text="", font=("Arial",10))
    lb20.grid(row=1+3, column=1, sticky=W)
    lb22 = Label(frame_nong_sung, text="", font=("Arial",10))
    lb22.grid(row=1+4, column=1, sticky=W)
    Label(frame_nong_sung, text="G1", font=("Arial",10)).grid(row=1+1, column=0, sticky=W)
    Label(frame_nong_sung, text="G2", font=("Arial",10)).grid(row=1+2, column=0, sticky=W)
    Label(frame_nong_sung, text="G3", font=("Arial",10)).grid(row=1+3, column=0, sticky=W)
    Label(frame_nong_sung, text="G4", font=("Arial",10)).grid(row=1+4, column=0, sticky=W)
    Label(frame_bom, text="BOM", font=("Arial",12, "bold")).grid(row=1+0, column=0, padx=5, pady=5, sticky=W+E, columnspan=2)
    lb25 = Label(frame_bom, text="", font=("Arial",10))
    lb25.grid(row=1+1, column=1, sticky=W)
    lb27 = Label(frame_bom, text="", font=("Arial",10))
    lb27.grid(row=1+2, column=1, sticky=W)
    Label(frame_bom, text="T", font=("Arial",10)).grid(row=1+1, column=0, sticky=W)
    Label(frame_bom, text="R", font=("Arial",10)).grid(row=1+2, column=0, sticky=W)
    Label(frame_dan, text="ĐẠN", font=("Arial",12, "bold")).grid(row=1+0, column=0, padx=5, pady=5, sticky=W+E, columnspan=2)
    lb30 = Label(frame_dan, text="", font=("Arial",10))
    lb30.grid(row=1+1, column=1, sticky=W)
    Label(frame_dan, text="T", font=("Arial",10)).grid(row=1+1, column=0, sticky=S)
    return lb3, lb5, lb7, lb9, lb11, lb13, lb16, lb18, lb20, lb22, lb25, lb27, lb30

def hinh_hop_chu_nhat(group2):
    button8 = Button(group2, text="Xóa", command=xoa_hinh3d, bg="green", fg="orange", width=26, height=1,font=("Arial", 12))
    button8.grid(row=6, column=0, padx=10, pady=10, columnspan=6)
    button9 = Button(group2, text="Vẽ", command=get_values_and_draw, bg="green", fg="orange", width=26, height=1,font=("Arial", 12))
    button9.grid(row=5, column=0, padx=10, pady=10, columnspan=6)
    Label(group2, text="X", font=("Arial",10)).grid(row=3, column=0, pady=5, sticky=W+E, columnspan=1)
    etr_x = Entry(group2, font=("Arial", 10), width=8)
    etr_x.grid(row=3, column=1, pady=5, sticky=W, columnspan=1)
    Label(group2, text="Y", font=("Arial",10)).grid(row=3, column=2, pady=5, sticky=W+E, columnspan=1)
    etr_y = Entry(group2, font=("Arial", 10), width=8)
    etr_y.grid(row=3, column=3, pady=5, sticky=W, columnspan=1)
    Label(group2, text="Z", font=("Arial",10)).grid(row=3, column=4, pady=5, sticky=W+E, columnspan=1)
    etr_z = Entry(group2, font=("Arial",10), width=8)
    etr_z.grid(row=3, column=5, pady=5, sticky=W, columnspan=1)
    Label(group2, text="Dài", font=("Arial",10)).grid(row=4, column=0, pady=5, sticky=W+E, columnspan=1)
    etr_d = Entry(group2, font=("Arial",10), width=8)
    etr_d.grid(row=4, column=1, pady=5, sticky=W, columnspan=1)
    Label(group2, text="Rộng", font=("Arial",10)).grid(row=4, column=2, pady=5, sticky=W+E, columnspan=1)
    etr_r = Entry(group2, font=("Arial",10), width=8)
    etr_r.grid(row=4, column=3, pady=5, sticky=W, columnspan=1)
    Label(group2, text="Cao", font=("Arial",10)).grid(row=4, column=4, pady=5, sticky=W+E, columnspan=1)
    etr_h = Entry(group2, font=("Arial",10), width=8)
    etr_h.grid(row=4, column=5, pady=5, sticky=W, columnspan=1)
    Label(group2, text="A:", font=("Arial",10)).grid(row=7, column=0, sticky=W+E, columnspan=1)
    lb1 = Label(group2, text="", font=("Arial",10))
    lb1.grid(row=7, column=1, sticky=W, columnspan=2)
    Label(group2, text="B:", font=("Arial",10)).grid(row=7, column=3, sticky=W+E, columnspan=1)
    lb2 = Label(group2, text="", font=("Arial",10))
    lb2.grid(row=7, column=4, sticky=W, columnspan=2)
    Label(group2, text="C:", font=("Arial",10)).grid(row=8, column=0, sticky=W+E, columnspan=1)
    lb3 = Label(group2, text="", font=("Arial",10))
    lb3.grid(row=8, column=1, sticky=W, columnspan=2)
    Label(group2, text="D:", font=("Arial",10)).grid(row=8, column=3, sticky=W+E, columnspan=1)
    lb4 = Label(group2, text="", font=("Arial",10))
    lb4.grid(row=8, column=4, sticky=W, columnspan=2)
    Label(group2, text="E:", font=("Arial",10)).grid(row=9, column=0, sticky=W+E, columnspan=1)
    lb5 = Label(group2, text="", font=("Arial",10))
    lb5.grid(row=9, column=1, sticky=W, columnspan=2)
    Label(group2, text="F:", font=("Arial",10)).grid(row=9, column=3, sticky=W+E, columnspan=1)
    lb6 = Label(group2, text="", font=("Arial",10))
    lb6.grid(row=9, column=4, sticky=W, columnspan=2)
    Label(group2, text="G:", font=("Arial",10)).grid(row=10, column=0, sticky=W+E, columnspan=1)
    lb7 = Label(group2, text="", font=("Arial",10))
    lb7.grid(row=10, column=1, sticky=W, columnspan=2)
    Label(group2, text="H:", font=("Arial",10)).grid(row=10, column=3, sticky=W+E, columnspan=1)
    lb8 = Label(group2, text="", font=("Arial",10))
    lb8.grid(row=10, column=4, sticky=W, columnspan=2)
    return etr_x, etr_y, etr_z, etr_d, etr_r, etr_h, lb1, lb2, lb3, lb4, lb5, lb6, lb7, lb8

def get_hinh_hop_chu_nhat(group2):
    for widget in group2.winfo_children():
        widget.destroy()
    gd_3D(group2)
    etr_x, etr_y, etr_z, etr_d, etr_r, etr_h, lb1, lb2, lb3, lb4, lb5, lb6, lb7, lb8 = hinh_hop_chu_nhat(group2)
    globals.etr_x, globals.etr_y, globals.etr_z, globals.etr_d, globals.etr_r, globals.etr_h, globals.lb1_h, globals.lb2_h, globals.lb3_h, globals.lb4_h, globals.lb5_h, globals.lb6_h, globals.lb7_h, globals.lb8_h = etr_x, etr_y, etr_z, etr_d, etr_r, etr_h, lb1, lb2, lb3, lb4, lb5, lb6, lb7, lb8

def get_hinh_tru(group2):
    for widget in group2.winfo_children():
        widget.destroy()
    gd_3D(group2)
    etr_x, etr_y, etr_z, etr_h, etr_bk1, lb1, lb2, lb3, lb4, lb5, lb6 = hinh_tru(group2)
    globals.etr_x, globals.etr_y, globals.etr_z, globals.etr_h, globals.etr_bk1, globals.lb1_t, globals.lb2_t, globals.lb3_t, globals.lb4_t, globals.lb5_t, globals.lb6_t = etr_x, etr_y, etr_z, etr_h, etr_bk1, lb1, lb2, lb3, lb4, lb5, lb6

def hinh_tru(group2):
    button8 = Button(group2, text="Xóa", command=xoa_hinh3d, bg="green", fg="orange", width=26, height=1,font=("Arial", 12))
    button8.grid(row=6, column=0, padx=10, pady=10, columnspan=6)
    button9 = Button(group2, text="Vẽ", command=get_values_cylinder, bg="green", fg="orange", width=26, height=1,font=("Arial", 12))
    button9.grid(row=5, column=0, padx=10, pady=10, columnspan=6)
    Label(group2, text="X", font=("Arial",10)).grid(row=3, column=0, pady=5, sticky=W+E, columnspan=1)
    etr_x = Entry(group2, font=("Arial", 10), width=6)
    etr_x.grid(row=3, column=1, pady=5, sticky=W, columnspan=1)
    Label(group2, text="Y", font=("Arial",10)).grid(row=3, column=2, pady=5, sticky=W+E, columnspan=1)
    etr_y = Entry(group2, font=("Arial",10), width=6)
    etr_y.grid(row=3, column=3, pady=5, sticky=W, columnspan=1)
    Label(group2, text="Z", font=("Arial",10)).grid(row=3, column=4, pady=5, sticky=W+E, columnspan=1)
    etr_z = Entry(group2, font=("Arial",10), width=6)
    etr_z.grid(row=3, column=5, pady=5, sticky=W, columnspan=1)
    Label(group2, text="Cao", font=("Arial",10)).grid(row=4, column=1, pady=5, sticky=W+E, columnspan=1)
    etr_h = Entry(group2, font=("Arial",10), width=6)
    etr_h.grid(row=4, column=2, pady=5, sticky=W, columnspan=1)
    Label(group2, text="R", font=("Arial",10)).grid(row=4, column=3, pady=5, sticky=W+E, columnspan=1)
    etr_bk1 = Entry(group2, font=("Arial",10), width=6)
    etr_bk1.grid(row=4, column=4, pady=5, sticky=W, columnspan=1)
    Label(group2, text="A:", font=("Arial",10)).grid(row=7, column=0, sticky=W+E, columnspan=1)
    lb1 = Label(group2, text="", font=("Arial",10))
    lb1.grid(row=7, column=1, sticky=W, columnspan=2)
    Label(group2, text="O:", font=("Arial",10)).grid(row=7, column=3, sticky=W+E, columnspan=1)
    lb2 = Label(group2, text="", font=("Arial",10))
    lb2.grid(row=7, column=4, sticky=W, columnspan=2)
    Label(group2, text="B:", font=("Arial",10)).grid(row=8, column=0, sticky=W+E, columnspan=1)
    lb3 = Label(group2, text="", font=("Arial",10))
    lb3.grid(row=8, column=1, sticky=W, columnspan=2)
    Label(group2, text="C:", font=("Arial",10)).grid(row=8, column=3, sticky=W+E, columnspan=1)
    lb4 = Label(group2, text="", font=("Arial",10))
    lb4.grid(row=8, column=4, sticky=W, columnspan=2)
    Label(group2, text="I:", font=("Arial",10)).grid(row=9, column=0, sticky=W+E, columnspan=1)
    lb5 = Label(group2, text="", font=("Arial",10))
    lb5.grid(row=9, column=1, sticky=W, columnspan=2)
    Label(group2, text="D:", font=("Arial",10)).grid(row=9, column=3, sticky=W+E, columnspan=1)
    lb6 = Label(group2, text="", font=("Arial",10))
    lb6.grid(row=9, column=4, sticky=W, columnspan=2)
    return etr_x, etr_y, etr_z, etr_h, etr_bk1, lb1, lb2, lb3, lb4, lb5, lb6

def gd_3D(group2):
    button6 = Button(group2, text="Hình Hộp Chữ Nhật", command=lambda: get_hinh_hop_chu_nhat(group2), bg="green", fg="orange", width=26, height=1,font=("Arial", 12),foreground="orange",)
    button6.grid(row=0, column=0, padx=30, pady=10, columnspan=6)
    button7 = Button(group2, text="Hình Trụ", command=lambda: get_hinh_tru(group2), bg="green", fg="orange", width=26, height=1,font=("Arial", 12))
    button7.grid(row=1, column=0, padx=10, pady=10, columnspan=6)